regina::LayeredChain Class Reference
Standard Triangulations and Subcomplexes

Represents a layered chain in a triangulation. More...

`#include <subcomplex/layeredchain.h>`

Inheritance diagram for regina::LayeredChain:

## Public Member Functions

| LayeredChain (Tetrahedron< 3 > *tet, Perm< 4 > vertexRoles)
| Creates a new layered chain containing only the given tetrahedron. More...
| LayeredChain (const LayeredChain &cloneMe)
| Creates a new layered chain that is a clone of the given structure. More...
virtual | ~LayeredChain ()
| Destroys this layered chain. More...
Tetrahedron< 3 > * | bottom () const
| Returns the bottom tetrahedron of this layered chain. More...
Tetrahedron< 3 > * | top () const
| Returns the top tetrahedron of this layered chain. More...
unsigned long | index () const
| Returns the number of tetrahedra in this layered chain. More...
Perm< 4 > | bottomVertexRoles () const
| Returns a permutation represeting the role that each vertex of the bottom tetrahedron plays in the layered chain. More...
Perm< 4 > | topVertexRoles () const
| Returns a permutation represeting the role that each vertex of the top tetrahedron plays in the layered chain. More...
bool | extendAbove ()
| Checks to see whether this layered chain can be extended to include the tetrahedron above the top tetrahedron (and still remain a layered chain). More...
bool | extendBelow ()
| Checks to see whether this layered chain can be extended to include the tetrahedron below the bottom tetrahedron (and still remain a layered chain). More...
bool | extendMaximal ()
| Extends this layered chain to a maximal length layered chain. More...
void | reverse ()
| Reverses this layered chain so the top tetrahedron becomes the bottom and vice versa. More...
void | invert ()
| Inverts this layered chain so the upper hinge becomes the lower and vice versa. More...
Manifold * | manifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
AbelianGroup * | homology () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | name () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | TeXName () const
| Returns the name of this specific triangulation in TeX format. More...
AbelianGroup * | homologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Static Public Member Functions

static StandardTriangulation * | isStandardTriangulation (Component< 3 > *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static StandardTriangulation * | isStandardTriangulation (Triangulation< 3 > *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Represents a layered chain in a triangulation.

A layered chain is a set of n tetrahedra glued to each other by layerings. For each tetrahedron, select two top faces, two bottom faces and two hinge edges, so that the top faces are adjacent, the bottom faces are adjacent, the hinge edges are opposite and each hinge meets both a top and a bottom face. The tetrahedron can thus be thought of as a fattened square with the top and bottom faces above and below the square respectively, and the hinges as the top and bottom edges of the square. The left and right edges of the square are identified to form an annulus.

For each i, the top faces of tetrahedron i are glued to the bottom faces of tetrahedron i+1. This is done by layering the upper tetrahedron upon the annulus formed by the top faces of the lower tetrahedron. The layering should be done over the left or right edge of the lower square (note that these two edges are actually identified). The top hinges of each tetrahedron should be identified, as should the bottom hinges.

The bottom faces of the first tetrahedron and the top faces of the last tetrahedron form the boundary of the layered chain. If there is more than one tetrahedron, the layered chain forms a solid torus with two vertices whose axis is parallel to each hinge edge.

The index of the layered chain is the number of tetrahedra it contains. A layered chain must contain at least one tetrahedron.

Note that for the purposes of manifold() and homology(), a layered chain containing only one tetrahedron will be considered as a standalone tetrahedron that forms a 3-ball (and not a solid torus).

All optional StandardTriangulation routines are implemented for this class.

## Constructor & Destructor Documentation

## LayeredChain() [1/2]

regina::LayeredChain::LayeredChain | ( | Tetrahedron< 3 > * | tet,
|  | Perm< 4 > | vertexRoles
| ) |  |

inline

Creates a new layered chain containing only the given tetrahedron.

This new layered chain will have index 1, but may be extended using extendAbove(), extendBelow() or extendMaximal().

Parameters

  tet | the tetrahedron that will make up this layered chain.
  vertexRoles | a permutation describing the role each tetrahedron vertex must play in the layered chain; this must be in the same format as the permutation returned by bottomVertexRoles() and topVertexRoles().

## LayeredChain() [2/2]

regina::LayeredChain::LayeredChain | ( | const LayeredChain & | cloneMe | ) |

inline

Creates a new layered chain that is a clone of the given structure.

Parameters

  cloneMe | the layered chain to clone.

## ~LayeredChain()

regina::LayeredChain::~LayeredChain | ( |  | ) |

inline virtual

Destroys this layered chain.

## Member Function Documentation

## bottom()

Tetrahedron< 3 > * regina::LayeredChain::bottom | ( |  | ) | const

inline

Returns the bottom tetrahedron of this layered chain.

Returns
  the bottom tetrahedron.

## bottomVertexRoles()

Perm< 4 > regina::LayeredChain::bottomVertexRoles | ( |  | ) | const

inline

Returns a permutation represeting the role that each vertex of the bottom tetrahedron plays in the layered chain.

The permutation returned (call this `p`) maps 0, 1, 2 and 3 to the four vertices of the bottom tetrahedron so that the edge from `p[0]` to `p[1]` is the top hinge, the edge from `p[2]` to `p[3]` is the bottom hinge, faces `p[1]` and `p[2]` are the (boundary) bottom faces and faces `p[0]` and `p[3]` are the top faces.

See the general class notes for further details.

Returns
  a permutation representing the roles of the vertices of the bottom tetrahedron.

## detail()

std::string regina::Output< StandardTriangulation , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## extendAbove()

bool regina::LayeredChain::extendAbove | ( |  | ) |

Checks to see whether this layered chain can be extended to include the tetrahedron above the top tetrahedron (and still remain a layered chain).

If so, this layered chain will be modified accordingly (note that its index will be increased by one and its top tetrahedron will change).

Returns
  `true` if and only if this layered chain was extended.

## extendBelow()

bool regina::LayeredChain::extendBelow | ( |  | ) |

Checks to see whether this layered chain can be extended to include the tetrahedron below the bottom tetrahedron (and still remain a layered chain).

If so, this layered chain will be modified accordingly (note that its index will be increased by one and its bottom tetrahedron will change).

Returns
  `true` if and only if this layered chain was extended.

## extendMaximal()

bool regina::LayeredChain::extendMaximal | ( |  | ) |

Extends this layered chain to a maximal length layered chain.

Both extendAbove() and extendBelow() will be used until this layered chain can be extended no further.

Returns
  `true` if and only if this layered chain was extended.

## homology()

AbelianGroup* regina::LayeredChain::homology | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::StandardTriangulation.

## homologyH1()

AbelianGroup * regina::StandardTriangulation::homologyH1 | ( |  | ) | const

inline inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

## index()

unsigned long regina::LayeredChain::index | ( |  | ) | const

inline

Returns the number of tetrahedra in this layered chain.

Returns
  the number of tetrahedra.

## invert()

void regina::LayeredChain::invert | ( |  | ) |

Inverts this layered chain so the upper hinge becomes the lower and vice versa.

The top and bottom tetrahedra will remain the top and bottom tetrahedra respectively.

Note that this operation will cause the hinge edges to point in the opposite direction around the solid torus formed by this layered chain.

Note that only the representation of the chain is altered; the underlying triangulation is not changed.

## isStandardTriangulation() [1/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Component< 3 > * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(Triangulation<3>*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

## isStandardTriangulation() [2/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Triangulation< 3 > * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(Component<3>*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

## manifold()

Manifold* regina::LayeredChain::manifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::StandardTriangulation.

## name()

std::string regina::StandardTriangulation::name | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

## reverse()

void regina::LayeredChain::reverse | ( |  | ) |

Reverses this layered chain so the top tetrahedron becomes the bottom and vice versa.

The upper and lower hinges will remain the upper and lower hinges respectively.

Note that this operation will cause the hinge edges to point in the opposite direction around the solid torus formed by this layered chain.

Note that only the representation of the chain is altered; the underlying triangulation is not changed.

## str()

std::string regina::Output< StandardTriangulation , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## TeXName()

std::string regina::StandardTriangulation::TeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

## top()

Tetrahedron< 3 > * regina::LayeredChain::top | ( |  | ) | const

inline

Returns the top tetrahedron of this layered chain.

Returns
  the top tetrahedron.

## topVertexRoles()

Perm< 4 > regina::LayeredChain::topVertexRoles | ( |  | ) | const

inline

Returns a permutation represeting the role that each vertex of the top tetrahedron plays in the layered chain.

The permutation returned (call this `p`) maps 0, 1, 2 and 3 to the four vertices of the top tetrahedron so that the edge from `p[0]` to `p[1]` is the top hinge, the edge from `p[2]` to `p[3]` is the bottom hinge, faces `p[1]` and `p[2]` are the bottom faces and faces `p[0]` and `p[3]` are the (boundary) top faces.

See the general class notes for further details.

Returns
  a permutation representing the roles of the vertices of the top tetrahedron.

## utf8()

std::string regina::Output< StandardTriangulation , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeName()

std::ostream & regina::LayeredChain::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTeXName()

std::ostream & regina::LayeredChain::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTextLong()

void regina::LayeredChain::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes a detailed text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::StandardTriangulation.

## writeTextShort()

void regina::StandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes a short text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

The documentation for this class was generated from the following file:

- subcomplex/layeredchain.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).